package org.processmining.plugins.workloadperiod.filter;

import javax.swing.JTable;

import au.id.dodson.FilterableSortableTable.FilterSortTable;

/**
 * Workload Analysis Filter
 * 
 * Given a Table and the filter Text, this table is filtered to obtain only the
 * rows that match the filter Text.
 * 
 * @author jnakatumba
 * 
 */

public class WLFilter {

	private static final long serialVersionUID = 2153260487648904935L;
	private String filterText;
	private JTable mainTable;

	private FilterSortTable sortTable;

	/**
	 * Filters the main Table based on the filter Text
	 * 
	 * @param filterName
	 * @param myTable
	 */
	public WLFilter(String filterName, JTable myTable) {
		this.filterText = filterName;
		this.mainTable = myTable;
		sortTable = new FilterSortTable();
		filter();
	}

	private void filter() {
	
		sortTable.setTableModel(mainTable.getModel());
		sortTable.setTableFilter(filterText);

	}


	public JTable getFilterTable() {
		mainTable = new JTable(sortTable.getModel());
		return mainTable;
	}

}