package org.processmining.plugins.workloadperiod.main;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.swing.JTable;

import org.processmining.framework.util.collection.ComparablePair;

/**
 * Workload Select Columns 
 * 	Selects specific columns from the table
 * 
 * @author jnakatumba
 * 
 * 
 */

public class WLSelectColumn {

	private JTable filterTable;

	private List<Date> compTimesList;
	private List<Date> startTimesList;

	private ComparablePair<Date, Long> startDuration;
	private ComparablePair<Date, Long> compDuration;

	private List<ComparablePair<Date, Long>> startDurationList;
	private List<ComparablePair<Date, Long>> compDurationList;

	public WLSelectColumn(JTable fTable) {
		this.filterTable = fTable;
		compTimesList = new ArrayList<Date>();
		startTimesList = new ArrayList<Date>();

		compDuration = new ComparablePair<Date, Long>(null, null);
		compDurationList = new ArrayList<ComparablePair<Date, Long>>();
		startDuration = new ComparablePair<Date, Long>(null, null);
		startDurationList = new ArrayList<ComparablePair<Date, Long>>();
		filterStartAndDuration();
		filterCompleteAndDuration();

	}

	private void filterStartAndDuration() {

		for (Integer colIndex = 0; colIndex < filterTable.getColumnCount(); colIndex++) {
			if (filterTable.getColumnName(colIndex).equals("Start Times")) {
				for (Integer rowIndex = 0; rowIndex < filterTable.getRowCount(); rowIndex++) {
					Object values = filterTable.getValueAt(rowIndex, colIndex);
					if (values != null) {
						Date cDate = (Date) values;
						startTimesList.add(cDate);

						now: for (Integer colIndex1 = 0; colIndex1 < filterTable.getColumnCount(); colIndex1++) {
							if (filterTable.getColumnName(colIndex1).equals("Service Times")) {
								for (Integer rowIndex5 = 0; rowIndex5 < filterTable.getRowCount(); rowIndex5++) {
									Object value = filterTable.getValueAt(rowIndex, colIndex1);
									Long duration = (Long) value;
									if (value != null) {
										startDuration = getCompDuration(cDate, duration);
										startDurationList.add(startDuration);
										break now;
									}
								}
							}
						}
					}
				}
			}
		}

	}

	private ComparablePair<Date, Long> getCompDuration(Date compDates, Long duration) {
		return new ComparablePair<Date, Long>(compDates, duration);
	}

	private void filterCompleteAndDuration() {
		for (Integer colIndex = 0; colIndex < filterTable.getColumnCount(); colIndex++) {
			if (filterTable.getColumnName(colIndex).equals("Completion Times")) {
				for (Integer rowIndex = 0; rowIndex < filterTable.getRowCount(); rowIndex++) {
					Object values = filterTable.getValueAt(rowIndex, colIndex);
					if (values != null) {
						Date cDate = (Date) values;
						compTimesList.add(cDate);

						now: for (Integer colIndex5 = 0; colIndex5 < filterTable.getColumnCount(); colIndex5++) {
							if (filterTable.getColumnName(colIndex5).equals("Service Times")) {
								for (Integer rowIndex5 = 0; rowIndex5 < filterTable.getRowCount(); rowIndex5++) {
									Object valueA = filterTable.getValueAt(rowIndex, colIndex5);
									Long duration = (Long) valueA;
									if (valueA != null) {
										compDuration = getCompDuration(cDate, duration);
										compDurationList.add(compDuration);
										break now;
									}
								}
							}
						}
					}
				}
			}
		}

	}

	public List<Date> getStartTimes() {
		return startTimesList;

	}

	public List<Date> getCompleteTimes() {
		return compTimesList;

	}

	public List<ComparablePair<Date, Long>> getStartDurations() {
		return startDurationList;

	}

	public List<ComparablePair<Date, Long>> getCompleteDurations() {
		return compDurationList;

	}
}
